/*******************************************************************************
* File Name: .h
* Version 2.40
*
* Description:
*  This private header file contains internal definitions for the SPIM
*  component. Do not use these definitions directly in your application.
*
* Note:
*
********************************************************************************
* Copyright 2012, Cypress Semiconductor Corporation. All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_SPIM_PVT_SD_SPIM_H)
#define CY_SPIM_PVT_SD_SPIM_H

#include "SD_SPIM.h"


/**********************************
*   Functions with external linkage
**********************************/


/**********************************
*   Variables with external linkage
**********************************/

extern volatile uint8 SD_SPIM_swStatusTx;
extern volatile uint8 SD_SPIM_swStatusRx;

#if(SD_SPIM_TX_SOFTWARE_BUF_ENABLED)
    extern volatile uint8 SD_SPIM_txBuffer[SD_SPIM_TX_BUFFER_SIZE];
    extern volatile uint8 SD_SPIM_txBufferRead;
    extern volatile uint8 SD_SPIM_txBufferWrite;
    extern volatile uint8 SD_SPIM_txBufferFull;
#endif /* (SD_SPIM_TX_SOFTWARE_BUF_ENABLED) */

#if(SD_SPIM_RX_SOFTWARE_BUF_ENABLED)
    extern volatile uint8 SD_SPIM_rxBuffer[SD_SPIM_RX_BUFFER_SIZE];
    extern volatile uint8 SD_SPIM_rxBufferRead;
    extern volatile uint8 SD_SPIM_rxBufferWrite;
    extern volatile uint8 SD_SPIM_rxBufferFull;
#endif /* (SD_SPIM_RX_SOFTWARE_BUF_ENABLED) */

#endif /* CY_SPIM_PVT_SD_SPIM_H */


/* [] END OF FILE */
