/*******************************************************************************
* File Name: UART1_Tx_SENDED.c  
* Version 1.70
*
*  Description:
*   API for controlling the state of an interrupt.
*
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/


#include <cydevice_trm.h>
#include <CyLib.h>
#include <UART1_Tx_SENDED.h>

#if !defined(UART1_Tx_SENDED__REMOVED) /* Check for removal by optimization */

/*******************************************************************************
*  Place your includes, defines and code here 
********************************************************************************/
/* `#START UART1_Tx_SENDED_intc` */

/* `#END` */

#ifndef CYINT_IRQ_BASE
#define CYINT_IRQ_BASE      16
#endif /* CYINT_IRQ_BASE */
#ifndef CYINT_VECT_TABLE
#define CYINT_VECT_TABLE    ((cyisraddress **) CYREG_NVIC_VECT_OFFSET)
#endif /* CYINT_VECT_TABLE */

/* Declared in startup, used to set unused interrupts to. */
CY_ISR_PROTO(IntDefaultHandler);


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_Start
********************************************************************************
*
* Summary:
*  Set up the interrupt and enable it.
*
* Parameters:  
*   None
*
* Return:
*   None
*
*******************************************************************************/
void UART1_Tx_SENDED_Start(void)
{
    /* For all we know the interrupt is active. */
    UART1_Tx_SENDED_Disable();

    /* Set the ISR to point to the UART1_Tx_SENDED Interrupt. */
    UART1_Tx_SENDED_SetVector(&UART1_Tx_SENDED_Interrupt);

    /* Set the priority. */
    UART1_Tx_SENDED_SetPriority((uint8)UART1_Tx_SENDED_INTC_PRIOR_NUMBER);

    /* Enable it. */
    UART1_Tx_SENDED_Enable();
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_StartEx
********************************************************************************
*
* Summary:
*  Set up the interrupt and enable it.
*
* Parameters:  
*   address: Address of the ISR to set in the interrupt vector table.
*
* Return:
*   None
*
*******************************************************************************/
void UART1_Tx_SENDED_StartEx(cyisraddress address)
{
    /* For all we know the interrupt is active. */
    UART1_Tx_SENDED_Disable();

    /* Set the ISR to point to the UART1_Tx_SENDED Interrupt. */
    UART1_Tx_SENDED_SetVector(address);

    /* Set the priority. */
    UART1_Tx_SENDED_SetPriority((uint8)UART1_Tx_SENDED_INTC_PRIOR_NUMBER);

    /* Enable it. */
    UART1_Tx_SENDED_Enable();
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_Stop
********************************************************************************
*
* Summary:
*   Disables and removes the interrupt.
*
* Parameters:  
*
* Return:
*   None
*
*******************************************************************************/
void UART1_Tx_SENDED_Stop(void)
{
    /* Disable this interrupt. */
    UART1_Tx_SENDED_Disable();

    /* Set the ISR to point to the passive one. */
    UART1_Tx_SENDED_SetVector(&IntDefaultHandler);
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_Interrupt
********************************************************************************
*
* Summary:
*   The default Interrupt Service Routine for UART1_Tx_SENDED.
*
*   Add custom code between the coments to keep the next version of this file
*   from over writting your code.
*
* Parameters:  
*
* Return:
*   None
*
*******************************************************************************/
CY_ISR(UART1_Tx_SENDED_Interrupt)
{
    /*  Place your Interrupt code here. */
    /* `#START UART1_Tx_SENDED_Interrupt` */

    /* `#END` */
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_SetVector
********************************************************************************
*
* Summary:
*   Change the ISR vector for the Interrupt. Note calling UART1_Tx_SENDED_Start
*   will override any effect this method would have had. To set the vector 
*   before the component has been started use UART1_Tx_SENDED_StartEx instead.
*
* Parameters:
*   address: Address of the ISR to set in the interrupt vector table.
*
* Return:
*   None
*
*******************************************************************************/
void UART1_Tx_SENDED_SetVector(cyisraddress address)
{
    cyisraddress * ramVectorTable;

    ramVectorTable = (cyisraddress *) *CYINT_VECT_TABLE;

    ramVectorTable[CYINT_IRQ_BASE + (uint32)UART1_Tx_SENDED__INTC_NUMBER] = address;
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_GetVector
********************************************************************************
*
* Summary:
*   Gets the "address" of the current ISR vector for the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   Address of the ISR in the interrupt vector table.
*
*******************************************************************************/
cyisraddress UART1_Tx_SENDED_GetVector(void)
{
    cyisraddress * ramVectorTable;

    ramVectorTable = (cyisraddress *) *CYINT_VECT_TABLE;

    return ramVectorTable[CYINT_IRQ_BASE + (uint32)UART1_Tx_SENDED__INTC_NUMBER];
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_SetPriority
********************************************************************************
*
* Summary:
*   Sets the Priority of the Interrupt. Note calling UART1_Tx_SENDED_Start
*   or UART1_Tx_SENDED_StartEx will override any effect this method 
*   would have had. This method should only be called after 
*   UART1_Tx_SENDED_Start or UART1_Tx_SENDED_StartEx has been called. To set 
*   the initial priority for the component use the cydwr file in the tool.
*
* Parameters:
*   priority: Priority of the interrupt. 0 - 7, 0 being the highest.
*
* Return:
*   None
*
*******************************************************************************/
void UART1_Tx_SENDED_SetPriority(uint8 priority)
{
    *UART1_Tx_SENDED_INTC_PRIOR = priority << 5;
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_GetPriority
********************************************************************************
*
* Summary:
*   Gets the Priority of the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   Priority of the interrupt. 0 - 7, 0 being the highest.
*
*******************************************************************************/
uint8 UART1_Tx_SENDED_GetPriority(void)
{
    uint8 priority;


    priority = *UART1_Tx_SENDED_INTC_PRIOR >> 5;

    return priority;
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_Enable
********************************************************************************
*
* Summary:
*   Enables the interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void UART1_Tx_SENDED_Enable(void)
{
    /* Enable the general interrupt. */
    *UART1_Tx_SENDED_INTC_SET_EN = UART1_Tx_SENDED__INTC_MASK;
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_GetState
********************************************************************************
*
* Summary:
*   Gets the state (enabled, disabled) of the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   1 if enabled, 0 if disabled.
*
*******************************************************************************/
uint8 UART1_Tx_SENDED_GetState(void)
{
    /* Get the state of the general interrupt. */
    return ((*UART1_Tx_SENDED_INTC_SET_EN & (uint32)UART1_Tx_SENDED__INTC_MASK) != 0u) ? 1u:0u;
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_Disable
********************************************************************************
*
* Summary:
*   Disables the Interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void UART1_Tx_SENDED_Disable(void)
{
    /* Disable the general interrupt. */
    *UART1_Tx_SENDED_INTC_CLR_EN = UART1_Tx_SENDED__INTC_MASK;
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_SetPending
********************************************************************************
*
* Summary:
*   Causes the Interrupt to enter the pending state, a software method of
*   generating the interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void UART1_Tx_SENDED_SetPending(void)
{
    *UART1_Tx_SENDED_INTC_SET_PD = UART1_Tx_SENDED__INTC_MASK;
}


/*******************************************************************************
* Function Name: UART1_Tx_SENDED_ClearPending
********************************************************************************
*
* Summary:
*   Clears a pending interrupt.
*
* Parameters:
*   None
*
* Return:
*   None
*
*******************************************************************************/
void UART1_Tx_SENDED_ClearPending(void)
{
    *UART1_Tx_SENDED_INTC_CLR_PD = UART1_Tx_SENDED__INTC_MASK;
}

#endif /* End check for removal by optimization */


/* [] END OF FILE */
